rockman=CreateSphere(3)					;Basic collision "shield"...
EntityType rockman,1					;I don't want to see it, and include it into collision
EntityRadius rockman,.20
EntityAlpha rockman,0
rockmanmod=CreateCube(rockman)			;The advanced sprite engine
ScaleEntity rockmanmod,.5,.5,.0000001	;Scale it so it's like a sprite
EntityAlpha rockmanmod,1
MoveEntity rockmanmod,0,.5,0			;Move it so it's just above the "shield"...
rockman_hd_chk=CreateSphere()			;The head check collision
EntityType rockman_hd_chk,3
ScaleEntity rockman_hd_chk,.1,.1,.1
EntityRadius rockman_hd_chk,.20
EntityAlpha rockman_hd_chk,0

rockman_run=LoadAnimTexture("rockmanneo_run2.bmp",5,49,49,0,3)		;Load the textures for the actual
rockman_run2=LoadAnimTexture("rockmanneo_run2.bmp",5,49,49,0,3)		;rockman image thingy...
ScaleTexture rockman_run2,-1,1
rockman_fire=LoadTexture("rockman_fire.bmp",5)
rockman_fire2=LoadTexture("rockman_fire.bmp",5)
ScaleTexture rockman_fire2,-1,1
rockman_stand=LoadTexture("rockman_stand.bmp",5)
rockman_stand2=LoadTexture("rockman_stand.bmp",5)
ScaleTexture rockman_stand2,-1,1

camera=CreateCamera()					;Create the camera
lite=CreateLight(camera)
MoveEntity camera,0,0,-5

lvl=LoadMesh("RMN_lvl1.b3d")			;Load the test level I made
MoveEntity lvl,555,555,555				;move them so there's no possible negative number
MoveEntity rockman,555,557,555			;( added just incase of network support...)
EntityType lvl,2						;Include in the collision as well

While Not KeyHit(1)						;Start the loop
If Not ChannelPlaying(music) Then music=PlayMusic("quick.s3m")
Cls
PositionEntity rockman_hd_chk,EntityX(rockman),EntityY(rockman)+.75,EntityZ(rockman)
;^^- Make sure the head check is always above the rockman model
Collisions 1,2,2,3						;<-- Do the collision stuff
Collisions 3,2,2,3
UpdateWorld
If EntityCollided(rockman_hd_chk,2) Then grundtouch=0: jump=0: jumptime=0: MoveEntity rockman,0,-.1,0
If EntityCollided(rockman,2) Then grundtouch=1
RenderWorld								;<< - Do all the rendering

Flip									;Duh!

;TurnEntity player,0,1,0
If MilliSecs()>movetimer+50				;Main movement timer
movetimer=MilliSecs()
MoveEntity rockman,0,-.5,0				;gravity stuff


playermode=2							;Handle all player inputs
If KeyDown(205) Then playermode=0: MoveEntity rockman,.5,0,0: dir=1
If KeyDown(203) Then playermode=0: MoveEntity rockman,-.5,0,0: dir=0
If KeyDown(200) Then playermode=0: MoveEntity rockman,0,0,.5
If KeyDown(208) Then playermode=0: MoveEntity rockman,0,0,-.5
If jumptime=0 And grundtouch=1 And KeyHit(57) Then jump=1: grundtouch=0

If KeyHit(47)							;A basic shot engine...
	For a#=-5 To 5
		shot.shot=New shot
		shot\spr=LoadSprite("shot_spr.bmp")
		If dir=1 Then PositionEntity shot\spr,EntityX(rockman)+Sin#(a#*5+90)-1,EntityY(rockman)+Cos#(a#*5+90)+1,EntityZ(rockman)
		If dir=0 Then PositionEntity shot\spr,EntityX(rockman)+Sin#(a#*5+90*(-1))+1,EntityY(rockman)+Cos#(a#*5+90*(-1))+1,EntityZ(rockman)
		ScaleSprite shot\spr,.25,.25
		EntityAlpha shot\spr,.25
		shot\dir#=dir
	Next
EndIf

For shot.shot=Each shot					;move each shot...
	MoveEntity shot\spr,(shot\dir#*2-1),0,0
	EntityColor shot\spr,Abs(Sin(MilliSecs()/2+Rnd(0,50))*250),Abs(Cos(MilliSecs()/3+Rnd(0,50))*250),Abs(Cos(MilliSecs()/4+Rnd(0,50))*250)
	shot\age=shot\age+1
	If shot\age=15 Then FreeEntity shot\spr: Delete shot
	;^^- If it's too old, then get rid of it!
Next

jumptime=jumptime+jump					;Handle the jumping stuff (IMPROVE PLEASE!!!)
If jumptime=15 Then jump=0: jumptime=0
If jumptime<>0 Then MoveEntity rockman,0,1,0

Select playermode+dir					;Handle what the player looks like!
	Case 0
		EntityTexture rockmanmod,rockman_run2,MilliSecs()/100 Mod 3
	Case 1
		EntityTexture rockmanmod,rockman_run,MilliSecs()/100 Mod 3
	Case 2
		EntityTexture rockmanmod,rockman_stand2
	Case 3
		EntityTexture rockmanmod,rockman_stand
End Select
PositionEntity camera,EntityX(rockman),EntityY(rockman)+2,EntityZ(rockman)-5
										;Ensure that the camera is with the player, but not as
										;a child...for better control anyways
EndIf

Wend